(provide 'emacs-mode)

(use-package 'line-edit-pkg)

(clear-global-set-key)

(global-set-key "\\C-@"		'set-mark-command)
(global-set-key "\\C-_"		'set-mark-command)
(global-set-key "\\C-^"		'scroll-down)
(global-set-key "\\C-a"		'beginning-of-line)
(global-set-key "\\C-b"		'backward-char)
(global-set-key "\\C-d"		'delete-char)
(global-set-key "\\C-e"		'end-of-line)
(global-set-key "\\C-f"		'forward-char)
(global-set-key "\\C-h"		'delete-backward-char)
(global-set-key "\\C-i"		'previous-line)
(global-set-key "\\C-j"		'self-insert-newline)
(global-set-key "\\C-k"		'kill-line)
(global-set-key "\\C-l"		'recenter)
(global-set-key "\\C-n"		'next-line)
(global-set-key "\\C-o"		'set-mark-command)
(global-set-key "\\C-p"		'previous-line)
(global-set-key "\\C-q"		'quoted-insert)
(global-set-key "\\C-s"		'isearch-forward)
(global-set-key "\\C-t"		'transpose-chars)
(global-set-key "\\C-u"		'universal-argument)
(global-set-key "\\C-v"		'scroll-up)
(global-set-key "\\C-w"		'kill-region)
(global-set-key "\\C-y"		'yank)
(global-set-key "\\M-("		'insert-parenthesis)
(global-set-key "\\M-,"		'advertised-undo)
(global-set-key "\\M-."		'advertised-redo)
(global-set-key "\\M-/"		'mark-word)
(global-set-key "\\M-<"		'beginning-of-history)
(global-set-key "\\M->"		'end-of-history)
(global-set-key "\\M-@"		'mark-word)
(global-set-key "\\M-\\\\"	'delete-horizontal-space)
(global-set-key "\\M-a"		'beginning-of-text)
(global-set-key "\\M-b"		'backward-word)
(global-set-key "\\M-c"		'capitalize-word)
(global-set-key "\\M-d"		'kill-word)
(global-set-key "\\M-e"		'end-of-text)
(global-set-key "\\M-f"		'forward-word)
(global-set-key "\\M-g"		'goto-global-mark)
(global-set-key "\\M-i"		'inspect-keycode)
(global-set-key "\\M-k"		'kill-text)
(global-set-key "\\M-l"		'downcase-word)
(global-set-key "\\M-m"		'set-global-mark)
(global-set-key "\\M-n"		'next-word)
(global-set-key "\\M-o"		'mark-sexp)
(global-set-key "\\M-p"		'move-to-matching-paren)
(global-set-key "\\M-r"		'recenter-zero)
(global-set-key "\\M-s"		'just-one-space)
(global-set-key "\\M-t"		'transpose-words)
(global-set-key "\\M-u"		'upcase-word)
(global-set-key "\\M-v"		'scroll-down)
(global-set-key "\\M-w"		'kill-ring-save)
(global-set-key "\\M-y"		'yank-pop)
(global-set-key "\\M-z"		'zap-to-char)
(global-set-key "\\M-[Rubout]"	'backward-kill-word)
(global-set-key "\\M-[Space]"	'just-one-space)
(global-set-key "\\M-\\C-@"	'mark-sexp)
(global-set-key "\\M-\\C-_"	'mark-sexp)
(global-set-key "\\M-\\C-o"	'mark-sexp)
(global-set-key "\\M-\\C-b"	'backward-sexp)
(global-set-key "\\M-\\C-c"	'line-edit-break)
(global-set-key "\\M-\\C-d"	'down-list)
(global-set-key "\\M-\\C-e"	'end-command-trace)
(global-set-key "\\M-\\C-f"	'forward-sexp)
(global-set-key "\\M-\\C-h"	'backward-kill-word)
(global-set-key "\\M-\\C-k"	'kill-sexp)
(global-set-key "\\M-\\C-n"	'forward-list)
(global-set-key "\\M-\\C-p"	'backward-list)
(global-set-key "\\M-\\C-s"	'start-command-trace)
(global-set-key "\\M-\\C-t"	'transpose-sexps)
(global-set-key "\\M-\\C-u"	'backward-up-list)
(global-set-key "\\M-\\C-w"	'append-next-kill)
(global-set-key "\\C-x ("	'start-kbd-macro)
(global-set-key "\\C-x )"	'end-kbd-macro)
(global-set-key "\\C-x <"	'scroll-left)
(global-set-key "\\C-x ="	'what-cursor-position)
(global-set-key "\\C-x >"	'scroll-right)
(global-set-key "\\C-x\\C-f"	'find-file)
(global-set-key "\\C-x\\C-k"	'edit-kbd-macro)
(global-set-key "\\C-x\\C-s"	'save-buffer)
(global-set-key "\\C-x\\C-u"	'up-list)
(global-set-key "\\C-x\\C-w"	'write-file)
(global-set-key "\\C-x\\C-x"	'exchange-point-and-mark)
(global-set-key "\\C-x e"	'call-last-kbd-macro)
(global-set-key "\\C-x i"	'insert-file)
(global-set-key "\\C-x q"	'kbd-macro-query)
(global-set-key "\\C-x u"	'advertised-undo)
(global-set-key "\\C-x U"	'advertised-redo)
(global-set-key "\\C-x r R"	'restore-registers)
(global-set-key "\\C-x r S"	'save-registers)
(global-set-key "\\C-x r i"	'insert-register)
(global-set-key "\\C-x r s"	'copy-to-register)

(define-key "[delete]"		"\\M-\\[\3\~")
(define-key "[Rubout]"		"\\C-h")
(define-key "[Backspace]"	"\\C-h")
(define-key "[Return]"		"\\C-m")
(define-key "[Linefeed]"	"\\C-j")

(global-set-key "[delete]"	'delete-char)
(global-set-key "[Rubout]"	'delete-backward-char)
(global-set-key "[Backspace]"	'delete-backward-char)
(global-set-key "[Return]"	'end-input)
(global-set-key "[Linefeed]"	'self-insert-newline)
(global-set-key "[Space]"	'self-insert-space)
(global-set-key "[0xa0]"	'just-one-space)	;M-[Space] generates 0xA0.

;;;     ESC [ A or ESC O A	;up-arrow
(global-set-key "\\M-\\[A"	'previous-line)
(global-set-key "\\M-O\A"	'previous-line)

;;;     ESC [ B or ESC O B	;down-arrow
(global-set-key "\\M-\\[\B"	'next-line)
(global-set-key "\\M-O\B"	'next-line)

;;;     ESC [ C or ESC O C	;right-arrow
(global-set-key "\\M-\\[\C"	'forward-char)
(global-set-key "\\M-O\C"	'forward-char)

;;;     ESC [ D or ESC O D	;left-arrow
(global-set-key "\\M-\\[\D"	'backward-char)
(global-set-key "\\M-O\D"	'backward-char)

(global-set-key nil		'self-insert)	;otherwise self-insert it.

(finish-global-set-key)		;sort global-keymap. optional.
